"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var taro_1 = require("@tarojs/taro");

var shared_1 = require("@taro-hooks/shared");

var taro_hooks_1 = require("taro-hooks");

var listeners = [];

function subscribeReVisible(listener) {
  listeners.push(listener);
  var visible = (0, taro_hooks_1.useVisible)();
  (0, taro_1.useTaroEffect)(function () {
    if ((0, shared_1.escapeState)(visible)) {
      for (var i = 0; i < listeners.length; i++) {
        var _listener = listeners[i];

        _listener();
      }
    }
  }, [visible]);
  return function unsubscribe() {
    var index = listeners.indexOf(listener);
    listeners.splice(index, 1);
  };
}

exports["default"] = subscribeReVisible;